/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package mathserver;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.StringTokenizer;

/**
 *
 * @author yunglu
 */
public class ClientHandler extends Thread {

    Socket chSocket;
    private PrintWriter chWriter;
    private BufferedReader chReader;

    public ClientHandler(Socket sock) {
        try {
            chSocket = sock;
            chWriter = new PrintWriter(sock.getOutputStream());
            InputStream in_stream = sock.getInputStream();
            InputStreamReader in_reader =
                    new InputStreamReader(in_stream);
            chReader = new BufferedReader(in_reader);
        } catch (Exception exp) {
        }
    }

    public void run() {
        try {
            boolean done = false;
            while (!done) {
                String inputString = chReader.readLine();
                if (inputString.equals("bye")) {
                    done = true;
                } else {
                    StringTokenizer stz = new StringTokenizer(inputString);
                    // the input should have op1 op op2 format
                    if (stz.countTokens() == 3) {
                        int operand1 = Integer.parseInt(stz.nextToken());
                        String operator = stz.nextToken();
                        int operand2 = Integer.parseInt(stz.nextToken());
                        int result = 0;
                        boolean valid = false;
                        if (operator.equals("+")) {
                            result = operand1 + operand2;
                            valid = true;
                        }
                        if (operator.equals("-")) {
                            result = operand1 - operand2;
                            valid = true;
                        }
                        if (operator.equals("*")) {
                            result = operand1 * operand2;
                            valid = true;
                        }   
                        String replyString = inputString;
                        if (valid == true) {
                            replyString += " = " + result;
                        } else {
                            replyString += " is invalid.";
                        }
                        chWriter.println(replyString);
                        chWriter.flush();
                    } else {
                        // ignore
                    }
                }
            }
            chReader.close();
            chWriter.close();
            chSocket.close();
        } catch (Exception exp) {
        }
    }
}
